<#ibiztemplate>
TARGET=PSAPPVIEWCTRL_SEARCHFORM
</#ibiztemplate>
package ${pub.getPKGCodeName()}.${de.getPSSystemModule().codeName?lower_case}.vo;

import java.sql.Timestamp;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import lombok.Data;
import ${pub.getPKGCodeName()}.${de.getPSSystemModule().codeName?lower_case}.service.dto.${de.codeName}SearchFilter;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import org.springframework.util.StringUtils;
import java.util.Map;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class ${de.codeName}_SearchForm_${ctrl.codeName}{

    private Map<String,String> srfparentdata;

<#list ctrl.getPSDEFormItems() as formitem>
    <#if formitem.getIgnoreInput() == 3>
    @JsonProperty(access=Access.READ_ONLY)
    </#if>
    <#if !formitem.isAllowEmpty()>
    @NotEmpty
    </#if>
    <#if formitem.getPSDEField()??>
        <#if !formitem.isAllowEmpty() && srfjavatype(formitem.getPSDEField().stdDataType)=='String'>
    @NotBlank
        </#if>
    private ${srfjavatype(formitem.getPSDEField().stdDataType)} ${formitem.name?lower_case};
    <#else>
    private String ${formitem.name?lower_case};
    </#if>
    <#if ( formitem.getCreateDV()?? && formitem.getCreateDV()?length gt 0) || ( formitem.getCreateDVT()?? && formitem.getCreateDVT()?length gt 0)>
        <#if formitem.getPSDEField()??><#comment>表单项有关联属性</#comment>
            <#if !P.exists("searchformitem","get",formitem.name)>
    private ${srfjavatype(formitem.getPSDEField().stdDataType)} get${formitem.name?lower_case?cap_first}(){
                <#if formitem.getPSDEField().getDataType()=='PICKUP'><#comment>外键值填充</#comment>
        <#assign psder1n=formitem.getPSDEField().getPSDER1N().name>
        if(StringUtils.isEmpty(${formitem.name?lower_case}) && this.getSrfparentdata() != null){
            if(this.getSrfparentdata().containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("${psder1n}"))
                this.${formitem.name?lower_case}=this.getSrfparentdata().get("srfparentkey");
        }
                </#if>
        if(StringUtils.isEmpty(${formitem.name?lower_case})){<#comment>上下文中填充</#comment>
                <#if formitem.getCreateDVT()=='PARAM'>
                    <#if srfjavatype(formitem.getPSDEField().stdDataType)=='String'>
            this.${formitem.name?lower_case}=this.getSrfparentdata().get("${formitem.getCreateDV()}");
                    <#else>
            //this.${formitem.name?lower_case}=this.getSrfparentdata().get("${formitem.getCreateDV()}");
                    </#if>
                <#else>
            //暂未实现   DefaultValue(value="${formitem.getCreateDV()}",type="${formitem.getCreateDVT()}")
                </#if>
        }
            return this.${formitem.name?lower_case};
    }
            </#if>
        <#else><#comment>表单项无关联属性</#comment>
            <#if !P.exists("searchformitem","get",formitem.name)>
        private String get${formitem.name?lower_case?cap_first}(){
         if(this.${formitem.name?lower_case}==null){
                <#if formitem.getCreateDVT()=='PARAM'>
             this.${formitem.name?lower_case}=this.getSrfparentdata().get("${formitem.getCreateDV()}");
                <#else>
             //暂未实现   DefaultValue(value="${formitem.getCreateDV()}",type="${formitem.getCreateDVT()}")
                </#if>
            }
             return this.${formitem.name?lower_case};
        }
            </#if>
        </#if>
    </#if>
</#list>
    private Page page;
    private Page getPage(){
        if(this.page==null)
            this.page=new Page(1,20,true);
        return this.page;
    }
    public  void from${de.codeName}SearchFilter(${de.codeName}SearchFilter sourceSearchFilter)  {
<#list ctrl.getPSDEFormItems() as formitem>
        this.set${formitem.name?lower_case?cap_first}(sourceSearchFilter.get${formitem.name?lower_case?cap_first}());
</#list>
        this.setPage(sourceSearchFilter.getPage());
	}
    public  ${de.codeName}SearchFilter to${de.codeName}SearchFilter()  {
        ${de.codeName}SearchFilter targetSearchFilter=new ${de.codeName}SearchFilter();
<#list ctrl.getPSDEFormItems() as formitem>
        if(targetSearchFilter.get${formitem.name?lower_case?cap_first}()==null)
            targetSearchFilter.set${formitem.name?lower_case?cap_first}(this.get${formitem.name?lower_case?cap_first}());
</#list>
        targetSearchFilter.setPage(this.getPage());
        return targetSearchFilter;
	}

<#comment>输出获取外键值方法-用于通过parentdata关系填充外键值id</#comment>
<#list ctrl.getPSDEFormItems() as formitem>
    <#if formitem.getPSDEField?? && formitem.getPSDEField()??>
        <#assign defield=formitem.getPSDEField()>
        <#if defield.getDataType()=='PICKUP'>
            <#if !P.exists("searchformitem","get",formitem.name)>
                <#assign psder1n=defield.getPSDER1N().name>
    //输出获取外键值方法-用于通过parentdata关系填充外键值id
    public String get${formitem.name?lower_case?cap_first}()
    {
        if(StringUtils.isEmpty(${formitem.name?lower_case}) && this.getSrfparentdata() != null)
        {
            if(this.getSrfparentdata().containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("${psder1n}"))
                this.${formitem.name?lower_case}=this.getSrfparentdata().get("srfparentkey");
        }
                return this.${formitem.name?lower_case};
    }
            </#if>
        </#if>
    </#if>
</#list>
}